Generates the list view.

package | lists
author | Pozdnyak Pavel

### Methods

## Constructor

    __construct(string $type) : \lamList

### Parameters

#### $type

`string`

account type

### Returns

`\lamList`list object

## Prints the HTML code to display the list view.

    showPage()

Inherited

inherited_from | \lamList::showPage()

## Can be used by subclasses to add e.g.

    addExtraInputElementsToTopArea(\htmlGroup $left, \htmlGroup $right)

Inherited

additional buttons to the top area.

inherited_from | \lamList::addExtraInputElementsToTopArea()

### Parameters

#### $left

`\htmlGroup`

left part

#### $right

`\htmlGroup`

right part

## Builds the LDAP filter based on the filter entries in the GUI.

    buildLDAPAttributeFilter() : String

Inherited

inherited_from | \lamList::buildLDAPAttributeFilter()

### Returns

`String`LDAP filter

## Returns if the given attribute can be filtered.

    canBeFiltered(String $attr) : boolean

Inherited

If filtering is not possible then no filter box will be displayed. By default all attributes can be filtered.

inherited_from | \lamList::canBeFiltered()

### Parameters

#### $attr

`String`

attribute name

### Returns

`boolean`filtering possible

## Forces a refresh of the LDAP data.

    forceRefresh()

Inherited

Function must be called before $this->refresh option is checked to load new LDAP data (e.g. in listGetParams).

inherited_from | \lamList::forceRefresh()

## Returns a list of additional LDAP attributes that should be read.

    getAdditionalLDAPAttributesToRead() : array

Inherited

This can be used to show additional data even if the user selected other attributes to show in the list.

inherited_from | \lamList::getAdditionalLDAPAttributesToRead()

### Returns

`array`additional attribute names

## Returns a list of lamListTool objects to display next to the edit/delete buttons.

    getAdditionalTools() : \lamListTool[]

Inherited

inherited_from | \lamList::getAdditionalTools()

### Returns

`\lamListTool[]`tools

## Returns the filter as text to be used as URL parameter.

    getFilterAsTextForURL() : String

Inherited

inherited_from | \lamList::getFilterAsTextForURL()

### Returns

`String`filter text

## Builds the regular expressions from the filter values.

    listBuildFilter()

Inherited

inherited_from | \lamList::listBuildFilter()

## Called when the configuration options changed.

    listConfigurationChanged()

Inherited

inherited_from | \lamList::listConfigurationChanged()

## Determines the sort mapping and stores it in $this->sortMapping.

    listCreateSortMapping(array $info)

Inherited

The sort mapping is used to display the right rows when the account table is created.

inherited_from | \lamList::listCreateSortMapping()

### Parameters

#### $info

`array`

the account list

## Manages all POST actions (e.g.

    listDoPost() : String

Inherited

button pressed) for the account lists.

inherited_from | \lamList::listDoPost()

### Returns

`String`HTML fragment to insert into beginning of account list

## Returns a list of possible configuration options.

    listGetAllConfigOptions() : array

Inherited

inherited_from | \lamList::listGetAllConfigOptions()

### Returns

`array`list of lamListOption objects

## Returns an hash array containing with all attributes to be shown and their descriptions.

    listGetAttributeDescriptionList() : array

Inherited

Format: array(attribute => description)

inherited_from | \lamList::listGetAttributeDescriptionList()

### Returns

`array`attribute list

## Returns the configuration option with the given ID.

    listGetConfigOptionByID(String $ID)

Inherited

inherited_from | \lamList::listGetConfigOptionByID()

### Parameters

#### $ID

`String`

ID

## Forces the list view to show only specific attributes.

    listGetParams()

see | \global\lamList::listGetParams()

## Prints the create and delete buttons.

    listPrintButtons(boolean $createOnly)

Inherited

inherited_from | \lamList::listPrintButtons()

### Parameters

#### $createOnly

`boolean`

true if only the create button should be displayed

## Prints the list configuration page.

    listPrintConfigurationPage()

Inherited

inherited_from | \lamList::listPrintConfigurationPage()

## Prints the HTML header.

    listPrintHeader()

Inherited

inherited_from | \lamList::listPrintHeader()

## Prints messages when another page (e.g.

    listPrintRedirectMessages()

Inherited

delete/upload) redirects to the list view.

inherited_from | \lamList::listPrintRedirectMessages()

## Prints the entry list

    listPrintTableBody(array $info)

Inherited

inherited_from | \lamList::listPrintTableBody()

### Parameters

#### $info

`array`

entries

## Prints the content of a cell in the account list for a given LDAP entry and attribute.

    listPrintTableCellContent(array $entry, string $attribute)

Inherited

inherited_from | \lamList::listPrintTableCellContent()

### Parameters

#### $entry

`array`

LDAP attributes

#### $attribute

`string`

attribute name

## Prints the attribute and filter row at the account table head

    listPrintTableHeader()

Inherited

inherited_from | \lamList::listPrintTableHeader()

## Groups the extensions.

    listRefreshData()

(non-PHPdoc)

see | \global\lamList::listRefreshData()

## Prints a combobox with possible sub-DNs.

    listShowOUSelection() : \htmlGroup

Inherited

inherited_from | \lamList::listShowOUSelection()

### Returns

`\htmlGroup`OU selection (may be empty)

## Prints the tool image links (e.g.

    listPrintToolLinks(array $account, String $id)

Inherited

edit and delete) for each account.

inherited_from | \lamList::listPrintToolLinks()

### Parameters

#### $account

`array`

LDAP attributes

#### $id

`String`

account ID

## Reads the list options from the cookie value.

    listReadOptionsFromCookie()

Inherited

inherited_from | \lamList::listReadOptionsFromCookie()

## Groups the extensions.

    normalizeLdapOutput(array $entries)

### Parameters

#### $entries

`array`

extension entries

## Shows the page where the user may select the PDF options.

    showPDFPage(String $id)

Inherited

inherited_from | \lamList::showPDFPage()

### Parameters

#### $id

`String`

account ID

### Properties

## list of LDAP attributes

    $attrArray

Inherited

inherited_from | \lamList::$$attrArray

## list of attribute descriptions

    $descArray

Inherited

inherited_from | \lamList::$$descArray

## LDAP entries

    $entries

Inherited

inherited_from | \lamList::$$entries

## list of filters (attribute name => filter input)

    $filters

Inherited

inherited_from | \lamList::$$filters

## list of account specific labels

    $labels

Inherited

inherited_from | \lamList::$$labels

## maximum count of entries per page

    $maxPageEntries

Inherited

inherited_from | \lamList::$$maxPageEntries

## current page number

    $page

Inherited

inherited_from | \lamList::$$page

## list of possible LDAP suffixes(organizational units)

    $possibleSuffixes

Inherited

inherited_from | \lamList::$$possibleSuffixes

## refresh page switch

    $refresh

Inherited

inherited_from | \lamList::$$refresh

## sort column name

    $sortColumn

Inherited

inherited_from | \lamList::$$sortColumn

## sort direction: 1 for ascending, -1 for descending

    $sortDirection

Inherited

inherited_from | \lamList::$$sortDirection

## sort mapping for entries array(original index => sorted index)

    $sortMapping

Inherited

inherited_from | \lamList::$$sortMapping

## LDAP suffix

    $suffix

Inherited

inherited_from | \lamList::$$suffix

## tabindex for GUI elements

    $tabindex

Inherited

inherited_from | \lamList::$$tabindex

## Account type

    $type

Inherited

inherited_from | \lamList::$$type

## configuration options

    $configOptions

Inherited

inherited_from | \lamList::$$configOptions

### Constants

## ID for list size config option

    LIST_SIZE_OPTION_NAME

Inherited

inherited_from | \lamList::LIST_SIZE_OPTION_NAME

## prefix for virtual (non-LDAP) attributes

    VIRTUAL_ATTRIBUTE_PREFIX

Inherited

inherited_from | \lamList::VIRTUAL_ATTRIBUTE_PREFIX